// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetProductListReq struct {
	Cid    int64  `form:"cid"`
	Size   uint32 `form:"size"`
	Page   uint32 `form:"page"`
	IsDemo uint32 `form:"is_demo" , options=0|1"`
}

type GetProductListRsp struct {
	Ob          Ob     `json:"ob"`
	TypeName    string `json:"typeName"`
	Description string `json:"description"`
}

type Ob struct {
	Items []Items `json:"items"`
	Links Links   `json:"_links"`
	Meta  Meta    `json:"_meta"`
}

type Meta struct {
	TotalCount  int32 `json:"totalCount"`
	PageCount   int32 `json:"pageCount"`
	CurrentPage int32 `json:"currentPage"`
	PerPage     int32 `json:"perPage"`
}

type Links struct {
	Self  HrefUrl `json:"self"`
	First HrefUrl `json:"first"`
	Last  HrefUrl `json:"last"`
	Next  HrefUrl `json:"next"`
}

type HrefUrl struct {
	Href string `json:"href"`
}

type Items struct {
	Id           int64   `json:"id"`
	Sn           string  `json:"sn"`
	Title        string  `json:"title"`
	Cover        string  `json:"cover"`
	Intro        string  `json:"intro"`
	CoverImg     string  `json:"cover_img"`
	IsEnv        int64   `json:"isEnv"`
	IsMicro      int64   `json:"isMicro"`
	SizeNum      uint32  `json:"sizeNum"`
	MiniPrice    float64 `json:"miniPrice"`
	CoverDefault string  `json:"coverDefault"`
}

type GetSuccessRecommandReq struct {
	Num  uint32 `form:"num"`
	Size uint32 `form:"size"`
	Sn   string `form:"sn"`
}

type GetSuccessRecommandRsp struct {
	Title        string `json:"title"`
	Cover        string `json:"cover"`
	CoverImg     string `json:"coverImg"`
	Sn           string `json:"sn"`
	Id           int64  `json:"id"`
	SkuId        int64  `json:"skuId"`
	CoverDefault string `json:"coverDefault"`
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	resp.Code = Code
	resp.Message = Message
	return resp
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	resp.Code = Code
	resp.Message = Message
	resp.Data = Data
	return resp
}

// SetMessage 设置Response的Message
func (resp *Response) SetMessage(msg string) *Response {
	resp.Message = msg
	return resp
}

// SetWithData 设置Data
func (resp *Response) SetData(Data interface{}) *Response {
	resp.Data = Data
	return resp
}

// SetWithData 设置Response的Code和Message值 带Data入参数
func (resp *Response) SetCode(Code int) *Response {
	resp.Code = Code
	return resp
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	resp.Code = sr.Code
	resp.Message = sr.Message
	if len(data) == 1 {
		resp.Data = data[0]
	}
	return resp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	resp.Code = sr.Code
	resp.Message = msg
	if len(data) == 1 {
		resp.Data = data[0]
	}
	return resp
}
